//Library scripts for enemy functions

#include "data/scripts/library/spawn.h"

void dasherP( float Vx, float Vy, int Flip)
{// Dash with desired speed!
// Won't apply if enemy is in midair
    void self = getlocalvar("self");
    int dir = getentityproperty(self,"direction");
    int y = getentityproperty(self, "a");
    int b = getentityproperty(self, "base");

    if(dir==0 && Flip==1){ // Facing left?
      Vx = -Vx ;
    }

    if(y <= b){
      changeentityproperty(self, "velocity", Vx, 0, Vy); //Move!
    }
}

void attack0(void Ani)
{// Attack interruption
    void self = getlocalvar("self");

    performattack(self, openborconstant(Ani)); //Attack!
}

void attack1(int RxMin, int RxMax, int RyMin, int RyMax, void Ani)
{// Attack interruption with range check
    void self = getlocalvar("self");
    void target = findtarget(self); //Get nearest player
    float x = getentityproperty(self, "x");
    float y = getentityproperty(self, "a");
    int dir = getentityproperty(self, "direction");

    if(target!=NULL()){
      float Tx = getentityproperty(target, "x");
      float Ty = getentityproperty(target, "a");
      float Disx = Tx - x;
      float Disy = Ty - y;

      if( Disx >= RxMin && Disx <= RxMax && Disy >= RyMin && Disy <= RyMax && dir == 1) // Target within range on right facing?
      {
        performattack(self, openborconstant(Ani)); //Change the animation
      } else if( Disx >= -RxMax && Disx <= -RxMin && Disy >= RyMin && Disy <= RyMax && dir == 0) // Target within range on left facing?
      {
        performattack(self, openborconstant(Ani)); //Change the animation
      }
    }
}

void StayPlat(int Rx, int Vx)
{// Finds platform edge within defined range. Turn around if edge is found
// Rx : Check distance in x axis
// Vx : Velocity to move
    void self = getlocalvar("self");
    int Dir = getentityproperty(self, "direction");
    int x = getentityproperty(self, "x");
    int y = getentityproperty(self, "a");
    int z = getentityproperty(self, "z");
    void Plat = checkplatformbelow(x, z, y+2);
    void PlatA; void PlatB;

    if(Plat){ // on a platform
      if(Dir==1){
        PlatA = checkplatformbelow(x+Rx, z, y+2);
        PlatB = checkplatformbelow(x+Rx, z, y-2);
      } else {
        PlatA = checkplatformbelow(x-Rx, z, y+2);
        PlatB = checkplatformbelow(x-Rx, z, y-2);
      }

      if(Plat!=PlatA && PlatA==PlatB && Dir==1){
        changeentityproperty(self, "velocity", -Vx);
        changeentityproperty(self, "direction", 0);
      } else if(Plat!=PlatA && PlatA==PlatB && Dir==0){
        changeentityproperty(self, "velocity", Vx);
        changeentityproperty(self, "direction", 1);
      }
    }
}

void StayWall(int Rx, int Vx)
{// Finds wall edge within defined range. Turn around if edge is found
// Rx : Check distance in x axis
// Vx : Velocity to move
    void self = getlocalvar("self");
    int Dir = getentityproperty(self, "direction");
    int x = getentityproperty(self, "x");
    int z = getentityproperty(self, "z");
    int Wall = checkwall(x,z);
    int WallC;

    if(Dir==1){
      WallC = checkwall(x+Rx,z);
    } else {
      WallC = checkwall(x-Rx,z);
    } 

    if(Wall!=0 && Wall > WallC && Dir==1){
      changeentityproperty(self, "velocity", -Vx);
      changeentityproperty(self, "direction", 0);
    } else if(Wall!=0 && Wall > WallC && Dir==0){
      changeentityproperty(self, "velocity", Vx);
      changeentityproperty(self, "direction", 1);
    }
}

void StayRoom(int Rx, int Vx)
{// Finds room edge within defined range. Turn around if edge is found
// Rx : Check distance in x axis
// Vx : Velocity to move
    void self = getlocalvar("self");
    int x = getentityproperty(self, "x");
    int Width = openborvariant("levelwidth");

    if(x > Width - Rx){
      changeentityproperty(self, "velocity", -Vx);
      changeentityproperty(self, "direction", 0);
    } else if(x < Rx){
      changeentityproperty(self, "velocity", Vx);
      changeentityproperty(self, "direction", 1);
    }
}

void Pala(float dx, float dy, int Num)
{ // Spawn random upper and bind it and store the part
    void self = getlocalvar("self");
    int map = getentityproperty(self,"map");
    int r = rand()%35 + 35;
    void Spawn;

    Spawn = spawnBind("Hed", dx, dy, 1, 1, 0, Num);

    changeentityproperty(Spawn, "map", map);

    if(r > 60){
      performattack(Spawn, openborconstant("ANI_FOLLOW6"));
    } else if(r > 50){
      performattack(Spawn, openborconstant("ANI_FOLLOW5"));
    } else if(r > 40){
      performattack(Spawn, openborconstant("ANI_FOLLOW4"));
    } else if(r > 30){
      performattack(Spawn, openborconstant("ANI_FOLLOW3"));
    } else if(r > 20){
      performattack(Spawn, openborconstant("ANI_FOLLOW2"));
    } else if(r > 10){
      performattack(Spawn, openborconstant("ANI_FOLLOW1"));
    }
}

void Pist(float dx, float dy, int Num)
{ // Spawn random turret and bind it and store the turret
    void self = getlocalvar("self");
    int map = getentityproperty(self,"map");
    int r = rand()%40 + 40;
    void Spawn;

    Spawn = spawnBind("Gan", dx, dy, 1, 1, 0, Num);

    changeentityproperty(Spawn, "map", map);

    if(r > 70){
      performattack(Spawn, openborconstant("ANI_FOLLOW7"));
    } else if(r > 60){
      performattack(Spawn, openborconstant("ANI_FOLLOW6"));
    } else if(r > 50){
      performattack(Spawn, openborconstant("ANI_FOLLOW5"));
    } else if(r > 40){
      performattack(Spawn, openborconstant("ANI_FOLLOW4"));
    } else if(r > 30){
      performattack(Spawn, openborconstant("ANI_FOLLOW3"));
    } else if(r > 20){
      performattack(Spawn, openborconstant("ANI_FOLLOW2"));
    } else if(r > 10){
      performattack(Spawn, openborconstant("ANI_FOLLOW1"));
    }
}

void Hulu(float dx, float dy, int Num)
{ // Spawn random head and bind it and store the head
    void self = getlocalvar("self");
    int map = getentityproperty(self,"map");
    int r = rand()%45 + 45;
    void Spawn;

    Spawn = spawnBind("Masto", dx, dy, 1, 1, 0, Num);

    changeentityproperty(Spawn, "map", map);

    if(r > 80){
      performattack(Spawn, openborconstant("ANI_FOLLOW8"));
    } else if(r > 70){
      performattack(Spawn, openborconstant("ANI_FOLLOW7"));
    } else if(r > 60){
      performattack(Spawn, openborconstant("ANI_FOLLOW6"));
    } else if(r > 50){
      performattack(Spawn, openborconstant("ANI_FOLLOW5"));
    } else if(r > 40){
      performattack(Spawn, openborconstant("ANI_FOLLOW4"));
    } else if(r > 30){
      performattack(Spawn, openborconstant("ANI_FOLLOW3"));
    } else if(r > 20){
      performattack(Spawn, openborconstant("ANI_FOLLOW2"));
    } else if(r > 10){
      performattack(Spawn, openborconstant("ANI_FOLLOW1"));
    }
}

void Bada(float dx, float dy, int Num)
{ // Spawn random torso and bind it and store the torso
    void self = getlocalvar("self");
    int map = getentityproperty(self,"map");
    int r = rand()%35 + 35;
    void Spawn;

    Spawn = spawnBind("Tors", dx, dy, 1, 1, 0, Num);

    changeentityproperty(Spawn, "map", map);

    if(r > 60){
      performattack(Spawn, openborconstant("ANI_FOLLOW6"));
    } else if(r > 50){
      performattack(Spawn, openborconstant("ANI_FOLLOW5"));
    } else if(r > 40){
      performattack(Spawn, openborconstant("ANI_FOLLOW4"));
    } else if(r > 30){
      performattack(Spawn, openborconstant("ANI_FOLLOW3"));
    } else if(r > 20){
      performattack(Spawn, openborconstant("ANI_FOLLOW2"));
    } else if(r > 10){
      performattack(Spawn, openborconstant("ANI_FOLLOW1"));
    }
}

void Topeng(float dx, float dy, int Num)
{ // Spawn random mask and bind it and store the mask
    int r = rand()%50 + 50;

    if(r > 10){
      void self = getlocalvar("self");
      int map = getentityproperty(self,"map");
      void Spawn;

      Spawn = spawnBind("Mask", dx, dy, 1, 1, 0, Num);

      changeentityproperty(Spawn, "map", map);

      if(r > 90){
        performattack(Spawn, openborconstant("ANI_FOLLOW8"));
      } else if(r > 80){
        performattack(Spawn, openborconstant("ANI_FOLLOW7"));
      } else if(r > 70){
        performattack(Spawn, openborconstant("ANI_FOLLOW6"));
      } else if(r > 60){
        performattack(Spawn, openborconstant("ANI_FOLLOW5"));
      } else if(r > 50){
        performattack(Spawn, openborconstant("ANI_FOLLOW4"));
      } else if(r > 40){
        performattack(Spawn, openborconstant("ANI_FOLLOW3"));
      } else if(r > 30){
        performattack(Spawn, openborconstant("ANI_FOLLOW2"));
      } else if(r > 20){
        performattack(Spawn, openborconstant("ANI_FOLLOW1"));
      }
    }
}

void postgun(float dx, float dy, int Num)
{ // Reposition bound gun based on number
    void self = getlocalvar("self");
    void Gun = getentityvar(self, Num);

    if(Gun){
      bindentity(Gun, self, dx, 1, dy, 1, 0);
    }
}

void phasegun(int Num, int Frame, int Flag)
{ // Change bound gun's frame based on number
    void self = getlocalvar("self");
    void Gun = getentityvar(self, Num);

    if(Gun){
      updateframe(Gun, Frame);

      if(Flag==1){
        changeentityproperty(Gun, "blink", 1);
      }
    }
}

void killgun(int Num, int Flag)
{ // Kill bound gun based on number
    void self = getlocalvar("self");
    void Gun = getentityvar(self, Num);

    if(Gun){
      bindentity(Gun, NULL());
      if(Flag==1){
        damageentity(Gun, self, 1000, 0, openborconstant("ATK_NORMAL2"));
      } else {
        killentity(Gun);
      }
    }
}

void dropgun(int Num, float Vx, float Vy)
{ // Drop n toss bound gun based on number
    void self = getlocalvar("self");
    void Gun = getentityvar(self, Num);

    if(Gun){
      bindentity(Gun, NULL());
      tossentity(Gun, Vy, Vx, 0);
    }
}

void Blinki()
{// Blink!
    void self = getlocalvar("self");

    changeentityproperty(self, "blink", 1);
}

void dropHealth(float dx, float dy)
{// Drops health randomly when player's HP is low
    void P1 = getplayerproperty(0, "entity");
    int HP1 = getentityproperty(P1, "health");
    int s = rand()%30;
    int r = rand()%4;

    if(HP1 <= 20 && s > 10){
      shooter("Health", dx, dy, r*0.1, 1.5);
    }
}

void dropMana(float dx, float dy)
{// Drops mana randomly when player's MP is low
    void P1 = getplayerproperty(0, "entity");
    int MP1 = getentityproperty(P1, "mp");
    int s = rand()%30;
    int r = rand()%4;

    if(MP1 <= 25 && s > -10){
      shooter("Mana", dx, dy, r*0.1, 1.5);
    }
}

void dropperI(float dx, float dy)
{// Drops random item
    int s = rand()%30;

    if(s > 0){
      dropHealth(dx, dy);
    } else {
      dropMana(dx, dy);
    }
}
