#import "data/scripts/library/spawn.h"
#import "data/scripts/library/basic.h"

void keyint(void Ani, int Frame, void Key, int Hflag)
{// Change current animation if proper key is pressed or released
// Animation is changed to attack mode

    void self = getlocalvar("self");
    int Dir = getentityproperty(self, "direction");
    int iPIndex = getentityproperty(self,"playerindex"); //Get player index
    void iRKey;

      if (Key=="U"){ //Up Required?
        iRKey = playerkeys(iPIndex, 0, "moveup"); // "Up"
      } else if (Key=="D"){ //Down Required?
        iRKey = playerkeys(iPIndex, 0, "movedown"); // "Down"
      } else if (Key=="L"){ //Left Required?
        iRKey = playerkeys(iPIndex, 0, "moveleft"); // "Left"
      } else if (Key=="R"){ //Right Required?
        iRKey = playerkeys(iPIndex, 0, "moveright"); // "Right"
      } else if (Key=="F"){ //Forward Required?
        if (Dir == 0){ // Facing Left?
          iRKey = playerkeys(iPIndex, 0, "moveleft"); // "Left"
        } else { // Facing Right
          iRKey = playerkeys(iPIndex, 0, "moveright"); // "Right"
        }
      } else if (Key=="B"){ //Backward Required?
        if (Dir == 1){ // Facing Right?
          iRKey = playerkeys(iPIndex, 0, "moveleft"); // "Left"
        } else { // Facing Left
          iRKey = playerkeys(iPIndex, 0, "moveright"); // "Right"
        }
      } else if (Key=="J"){ //Jump Required?
        iRKey = playerkeys(iPIndex, 0, "jump"); // "Jump"
      } else if (Key=="A"){ //Attack Required?
        iRKey = playerkeys(iPIndex, 0, "attack"); // "Attack"
      } else if (Key=="A2"){ //Attack Required?
        iRKey = playerkeys(iPIndex, 0, "attack2"); // "Attack2"
      } else if (Key=="S"){ //Special Required?
        iRKey = playerkeys(iPIndex, 0, "special"); // "Special"
      }

      if (Hflag==1){ //Not holding the button case?
        iRKey = !iRKey; //Take the opposite condition
      }

      if (iRKey){
        if (Ani=="ANI_IDLE"){ // Going idle?
          setidle(self, openborconstant("ANI_IDLE")); //Be idle!
        } else {
          performattack(self, openborconstant(Ani)); //Change the animation
        }
        updateframe(self, Frame); //Change frame
      }
}

void keymove(float Vx)
{// Move hero if direction button is pressed
      void self = getlocalvar("self");
      int iPIndex = getentityproperty(self,"playerindex"); //Get player index
	float xdir = 0;

      if (playerkeys(iPIndex, 0, "moveleft")){// Left is pressed?
	  xdir = -Vx;
	} else if(playerkeys(iPIndex, 0, "moveright")){// Right is pressed?
	  xdir = Vx;
      }

	changeentityproperty(self, "velocity", xdir);
}

void keyshoot(void Shot, float dx, float dy, float Vx, int Time)
{// Shoots projectile with time control
//Only fires if Attack1 button is held
    void self = getlocalvar("self");
    int TPhase = getentityvar(self, "Phase");
    int iPIndex = getentityproperty(self,"playerindex"); //Get player index
    int SFX = loadsample("data/sounds/shoot.wav");

    if(playerkeys(iPIndex, 0, "attack")){
      if(TPhase != NULL() && TPhase <= openborvariant("elapsed_time")){
        setentityvar(self, "Phase", NULL());
        TPhase = NULL();
      }
      if(TPhase == NULL()){
        playsample(SFX, 0, 120, 120, 100, 0);
        setentityvar(self, "Phase", openborvariant("elapsed_time") + 2*Time);
 
        shooter(Shot, dx, dy, 0, Vx, 0, 0);
      }
    }
}

void Decremmo(int S)
{// Decrements shuriken ammo
    int Ammo = getglobalvar("BilShur");

    setglobalvar("BilShur", Ammo-S);
}

void AmmoLimit(void Ani)
{// Changes animation if shuriken ammo is 0
    void self = getlocalvar("self");
    int Ammo = getglobalvar("BilShur");

    if(Ammo <= 0){
      setglobalvar("BilWep", 0);
      changeentityproperty(self, "animation", openborconstant(Ani));
    }
}

void spawnM(void Name, float dx, float dy, float dz)
{ // Spawn certain entity and matches its map with own's map
   void self = getlocalvar("self");
   int map = getentityproperty(self,"map");
   void Spawn;

   Spawn = spawn01(Name, dx, dy, dz);
   changeentityproperty(Spawn, "map", map);
}

void bbounce(void Ani){
	// Check altitude. If projectile is on ground, change animation!
    void self = getlocalvar("self"); // Get self
    int x = getentityproperty(self,"x"); // Get self x pos
    int z = getentityproperty(self,"z"); // Get self z pos
    int y = getentityproperty(self,"a"); // Get self altitude
    int H = checkhole(x,z,y-100); // Checkhole

    if( y <= 1 && H != 1)
	{ // On ground but not on hole?
      changeentityproperty(self, "animation", openborconstant(Ani));
	  // Change to desired animation
    }
}

void leaper( float Vx, float Vy, int Flip)
{// Leap with desired speed!
    void self = getlocalvar("self");
    int dir = getentityproperty(self,"direction");

    if(dir==0 && Flip==1){ // Facing left?
      Vx = -Vx ;
    }

    tossentity(self, Vy, Vx); //Leap!
}


void keyLoop(void key, int frame)
{//Loops defined frame if defined key is held
	void self 	= getlocalvar("self");
	int iPIndex = getentityproperty(self,"playerindex");

	if(playerkeys(iPIndex, 0, key)){updateframe(self, frame);}
}

void aniChange(int type, void ani)
{//Change animations
 //Type 0: Default animation changer
 //Type 1: Execute animation changer
 //Type 2: Performattack animation changer
	void self = getlocalvar("self");

    if(type == 0){changeentityproperty(self, "animation", openborconstant(ani));}
	  if(type == 1){executeanimation(self, openborconstant(ani), 1);}
  	if(type == 2){performattack(self, openborconstant(ani), 1);}
}

void SmartDrops(void Ent, int Alt, int Vx, int Vy)
{/*
    Drops something on enemies    
    Ent: Name of entity to be dropped
    Vx : x velocity
    Vy : y velocity
    */
    void vEntity;                                     //Target entity placeholder.
    int  iEntity;                                     //Entity enumeration holder.
    int  iType;                                       //Entity type.
    int  iAnim;                                       //Entity animation.
    int  iDir;                                       //Entity type.
    int  iMax      = openborvariant("count_entities");  //Entity count.
    int  iHealth;                                       //Entity health.
    void Drop; int iEx; int iEz; int xDist;

     //Enumerate and loop through entity collection.
    for(iEntity=0; iEntity<iMax; iEntity++){    
        vEntity = getentity(iEntity);                 //Get target entity from current loop.
        iType   = getentityproperty(vEntity, "type"); //Get target type.
        iHealth = getentityproperty(vEntity, "health");
        iAnim   = getentityproperty(vEntity,"animationID");

	if(iType == openborconstant("TYPE_ENEMY") && iHealth > 0){ // enemy type?
	  if(iAnim != openborconstant("ANI_SPAWN") && iAnim != openborconstant("ANI_FOLLOW1") && iAnim != openborconstant("ANI_FOLLOW2")){ // not in forbidden animations?
	    void self = getlocalvar("self");
	    int Dir = getentityproperty(self,"direction");

            iEx = getentityproperty(vEntity,"x");
            iEz = getentityproperty(vEntity,"z");

	    if(Vy < 0){     
	      Vy = -Vy; //Reverse Vy direction to make it positive  
	    }

	    xDist = 2*Vx*Alt/Vy;

	    if(Dir == 0){ //Is entity facing left?                  
	      xDist = -xDist; //Reverse Vx direction to match facing       
	      Vx = -Vx; //Reverse Vx direction to match facing  
	    }

	    Drop = spawn01(Ent, 0, 0, 0);

	    changeentityproperty(Drop, "position", iEx-xDist, iEz, Alt);
	    changeentityproperty(Drop, "velocity", Vx, 0, -Vy);
          }
	}
    }
}

void SmartHurt(float Damage, int Knock, int Tipe, int Arah)
{/*
    Originally smartbomb by
    Damon Vaughn Caskey
    07152008

    Hurt effect which hits all enemies
    
    Damage: how much damage enemies will take
    Knock: how much knockdown power enemies will take
    Tipe: which damage type enemies will take
    */
    void vSelf     = getlocalvar("self");             //Caller.
    void vEntity;                                     //Target entity placeholder.
    int  iEntity;                                     //Entity enumeration holder.
    int  iType;                                       //Entity type.
    int  iAnim;                                       //Entity animation.
    int  iDir;                                       //Entity direction.
    int  iHealth;                                       //Entity health.
    int  iMax      = openborvariant("count_entities");  //Entity count.

     //Enumerate and loop through entity collection.
    for(iEntity=0; iEntity<iMax; iEntity++){    
        vEntity = getentity(iEntity);                 //Get target entity from current loop.
        iType   = getentityproperty(vEntity, "type"); //Get target type.
        iHealth = getentityproperty(vEntity, "health");
        iAnim   = getentityproperty(vEntity,"animationID");

	if(iType == openborconstant("TYPE_ENEMY") && iHealth > 0){ // enemy type?
	  if(iAnim != openborconstant("ANI_SPAWN") && iAnim != openborconstant("ANI_FOLLOW1") && iAnim != openborconstant("ANI_FOLLOW2")){ // not in forbidden animations?
            int Dir = getentityproperty(vSelf, "direction");

	    if(Arah == -1){
	      if(Dir == 1){
	        iDir = 0;
	      } else { iDir = 1; }
	    } else {
	      iDir = Dir;
	    }

	    changeentityproperty(vEntity, "position", NULL(), NULL(), 0);

	    if(Tipe == 7){
	      damageentity(vEntity, vEntity, Damage, Knock, openborconstant("ATK_NORMAL7"));
  	    } else if(Tipe == 6){
  	      damageentity(vEntity, vEntity, Damage, Knock, openborconstant("ATK_NORMAL6"));
	    } else if(Tipe == 5){
	      damageentity(vEntity, vEntity, Damage, Knock, openborconstant("ATK_NORMAL5"));
	    } else if(Tipe == 4){
	      damageentity(vEntity, vEntity, Damage, Knock, openborconstant("ATK_NORMAL4"));
	    } else if(Tipe == 3){
	      damageentity(vEntity, vEntity, Damage, Knock, openborconstant("ATK_NORMAL3"));
	    } else if(Tipe == 2){
	      damageentity(vEntity, vEntity, Damage, Knock, openborconstant("ATK_NORMAL2"));
	    } else {
	      damageentity(vEntity, vEntity, Damage, Knock, openborconstant("ATK_NORMAL"));
	    }
	    changeentityproperty(vEntity, "direction", iDir);
          }
	}
    }
}
