#import "data/scripts/library/spawn.h"
#import "data/scripts/library/basic.h"
#import "data/scripts/library/enemies.h"

void countdown()
{
	int ls = getlocalvar("lifespan");
	if(ls==NULL())
	{
		ls = 0;
	}
	else if(ls>3)
	{
		changeentityproperty(getlocalvar("self"), "animation", openborconstant("ANI_DIE"));
	}
	else
	{
		ls++;
	}
	setlocalvar("lifespan", ls);
}

void escape()
{
	void self = getlocalvar("self");
	void e;
	clearspawnentry();
	setspawnentry("name", "escsanta");
	e = spawn();

	changeentityproperty(e, "position", getentityproperty(self, "x"), getentityproperty(self, "z"), getentityproperty(self, "a"));
	changeentityproperty(e, "base", getentityproperty(self, "base"));
	changeentityproperty(e, "map", getentityproperty(self, "map"));

	if(getlocalvar("lifespan")>3)
	{
		changeentityproperty(e, "animation", openborconstant("ANI_RESPAWN"));
	}

	if(getentityproperty(self, "direction")==1)
	{
		changeentityproperty(e, "velocity", 3, 0, 0);
		changeentityproperty(e, "direction", 1);
	}
	else
	{
		changeentityproperty(e, "velocity", -3, 0, 0);
		changeentityproperty(e, "direction", 0);
	}
	killentity(self);
}


void changedir()
{
    void self = getlocalvar("self");
    float x = getentityproperty(self, "x");
    float z = getentityproperty(self, "z");
    float a = getentityproperty(self, "a");
    float va = getentityproperty(self, "tossv");
    float vx = getentityproperty(self, "xdir");
    float vz = getentityproperty(self, "zdir");
    int d = getentityproperty(self, "direction");
    float wall;
    if(vx>0)
    {
        wall = checkwall(4 + x, z);
        if( wall>a || (wall==0 && checkhole(4 + x, z)) )
        {
            d=0;vx=-1.6;
        }
    }
    else if(vx<0)
    {
        wall = checkwall(x-4, z);
        if( wall>a || (wall==0 && checkhole(x-4, z)) )
        {
            d=1;vx=1.6;
        }
    }
    if(getentityproperty(self, "animationid")==openborconstant("ANI_WALK") && !vx)
    {
        wall = checkwall(x, 8 + z);
        if( 8 + z > getglobalvar("levelmaxz") || wall>a || (wall==0 && checkhole (x, 8 + z)) )
        {
            vz = -0.8;
            changeentityproperty(self, "animation", openborconstant("ANI_UP"));
        }
    }
	else if(getentityproperty(self, "animationid")==openborconstant("ANI_UP") )
	{
        wall = checkwall(x, z-8);
        if(z-8 < getglobalvar("levelminz") || wall>a || (wall==0 && checkhole (x, z-8)) )
        {
            vz = 0.8;
            changeentityproperty(self, "animation", openborconstant("ANI_WALK"));
        }
	}
    changeentityproperty(self, "velocity", vx, vz, va);
    changeentityproperty(self, "direction", d);
}

void runaway()
{
    void self = getlocalvar("self");
    float x = getentityproperty(self, "x");
    float z = getentityproperty(self, "z");
    float a = getentityproperty(self, "a");
    float vx = getentityproperty(self, "xdir");
    float va = getentityproperty(self, "tossv");
    float vz = getentityproperty(self, "zdir");

	float xpos = openborvariant("xpos");

	if(x<xpos - 30 || x> xpos + getindexedvar(11) + 30)
	{
		killentity(self);
	}
	else
	{
		int d = getentityproperty(self, "direction");
		float wall;
		float wb;

		if(d==0)
		{
			d = -1;
		}

		wall = checkwall(x + 10*d, z);
		wb = checkwall(x - 60*d, z);

		if(wall>0 && wall>a+20)
		{
			if(wb > a) { vz = 1.5;}
			changeentityproperty(self, "velocity", -3*d, vz+0.5, va);
			if(d > 0) // flip
			{
				changeentityproperty(self, "direction", 0);
			}
			else
			{
				changeentityproperty(self, "direction", 1);
			}
		}
		else if(wall>0 && wall>a)
		{
			changeentityproperty(self, "base", wall);
			changeentityproperty(self, "position", x, z, wall+0.5);
			changeentityproperty(self, "velocity", 3*d, 0, va);
		}
		else
		{
			changeentityproperty(self, "velocity", 3*d, vz, va);
		}
		
	}

}

void MonoAttack(void Ani, int Ratio)
{ // Randomly changes animation into specified animation 
    if(Ratio >= 50 - rand()%50){
      void self = getlocalvar("self");

      performattack(self, openborconstant(Ani));
    }
}

void CountEAct(void Ani, int Limit)
{// Changes animation if number of enemies fall below limit
    int En = openborvariant("count_enemies");
 
    if(En <= Limit){
      void self = getlocalvar("self");

      performattack(self, openborconstant(Ani));
    }
}
